 /*
 * Admin Entity has all variables and it's setter and getter methods as well the NamedQueries
 * It handles the relationship based notataion not using the queries
 * 
 */
package com.entity;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 *
 * @author Badal
 */
@Entity
@NamedQueries({
    @NamedQuery(name = Admin.FIND_ALL, query = "SELECT c FROM Admin c"),
    @NamedQuery(name = Admin.FIND_ADMIN, query = "SELECT c FROM Admin c WHERE c.email = ?1"),
    @NamedQuery(name = Admin.LOGIN_VERIFICATION, query = "SELECT c FROM Admin c WHERE c.email = ?1 AND c.password = ?2")
})
public class Admin implements Serializable {

    //variables declaration
    private static final long serialVersionUID = 1L;
    public static final String FIND_ALL = "Admin.findAll";
    public static final String FIND_ADMIN = "Admin.findAdmin";
    public static final String LOGIN_VERIFICATION = "Admin.loginVerification";
    
    // ID is primary key and autogenerated
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    private String email;
    private String password;

    // Getter and Setter methods for all variables
    
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Admin)) {
            return false;
        }
        Admin other = (Admin) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    // toString method to retrive data of the variables
    @Override
    public String toString() {
        return "com.entity.Admin[ id=" + id + " ]";
    }
    
}
