/*
 * Category Entity has all variables and it's setter and getter methods as well the NamedQueries
 * It handles the relationship based notataion not using the queries
 * 
 */
package com.entity;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 *
 * @author Badals
 */
@Entity
@NamedQueries({
    @NamedQuery(name = Category.FIND_ALL, query = "SELECT c FROM Category c"),
    @NamedQuery(name = Category.SEARCH_BY_CATEGORY_ID, query = "SELECT c FROM Category c WHERE c.id LIKE ?1"),
    @NamedQuery(name = Category.SEARCH_BY_CATEGORY_NAME, query = "SELECT c FROM Category c WHERE c.categoryName LIKE ?1")
})
public class Category implements Serializable {

    private static final long serialVersionUID = 1L;
    public static final String FIND_ALL = "Category.findAll";
    public static final String SEARCH_BY_CATEGORY_ID = "Category.search";
    public static final String SEARCH_BY_CATEGORY_NAME = "Category.searchByName";
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    private String categoryName;
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCategoryName() {
        return categoryName;
    }

    public void setCategoryName(String categoryName) {
        this.categoryName = categoryName;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Category)) {
            return false;
        }
        Category other = (Category) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.entity.Category[ id=" + id + " categoryName=" + categoryName + " ]";
    }
    
}